jbuilder-exec(1)

NAME

jbuilder-exec - Execute a command in a similar environment as if installation was performed.

SYNOPSIS

jbuilder exec [OPTION]... PROG [ARGS]...

DESCRIPTION

jbuilder exec -- COMMAND should behave in the same way as if you do:

  $ jbuilder install
  $ COMMAND

In particular if you run jbuilder exec ocaml, you will have access to the libraries defined in the workspace using your usual directives (#require for instance)

OPTIONS

--context=CONTEXT (absent=default)
    Run the command in this build context.

--help[=FMT] (default=auto)
    Show this help in format FMT. The value FMT must be one of `auto', `pager', `groff' or `plain'. With `auto', the format is `pager` or `plain' whenever the TERM env var is `dumb' or undefined.

--version
    Show version information.

COMMON OPTIONS

These options are common to all commands.

--debug-backtraces
    Always print exception backtraces.

--debug-dependency-path
    In case of error, print the dependency path from the targets on the command line to the rule that failed.

--debug-findlib
    Debug the findlib sub-system.

--dev
    Use stricter compilation flags by default.

-j JOBS (absent=4)
    Run no more than JOBS commands simultaneously.

--no-buffer
    Do not buffer the output of commands executed by jbuilder. By default jbuilder buffers the output of subcommands, in order to prevent interleaving when multiple commands are executed in parallel. However, this can be an issue when debugging long running tests. With --no-buffer, commands have direct access to the terminal. Note that as a result their output won't be captured in the log file. You should use this option in conjunction with -j 1, to avoid interleaving. Additionally you should use --verbose as well, to make sure that commands are printed before they are being executed.

--only-packages=PACKAGES
    Ignore stanzas referring to a package that is not in PACKAGES. PACKAGES is a comma-separated list of package names. Note that this has the same effect as deleting the relevant stanzas from jbuild files. It is mostly meant for releases. During development, it is likely that what you want instead is to build a particular <package>.install target.

-p PACKAGES, --for-release-of-packages=PACKAGES
    Shorthand for --root . --only-packages PACKAGE. You must use this option in your <package>.opam files, in order to build only what's necessary when your project contains multiple packages as well as getting reproducible builds.

--root=DIR
    Use this directory as workspace root instead of guessing it. Note that this option doesn't change the interpretation of targets given on the command line. It is only intended for scripts.

--verbose
    Print detailed information about commands being run

--workspace=FILE
    Use this specific workspace file instead of looking it up.

MORE HELP

Use `jbuilder COMMAND --help' for help on a single command.

BUGS

Check bug reports at https://github.com/janestreet/jbuilder/issues